//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1  LimeGreen
#property indicator_color2  PaleVioletRed
#property indicator_width1  2
#property indicator_width2  2
#property indicator_minimum 0
#property indicator_maximum 1

//
//
//
//
//

extern bool   UseOSMA              = true;
extern int    OSMAFastPeriod       = 12;
extern int    OSMASlowPeriod       = 26;
extern int    OSMASignalPeriod     = 9;
extern int    OSMAPrice            = PRICE_CLOSE;
extern bool   UseEldersImpulse     = true;
extern int    EimpEmaPeriod        = 13;
extern int    EimpMacdFastPeriod   = 12;
extern int    EimpMacdSlowPeriod   = 26;
extern int    EimpMacdSignalPeriod =  9;
extern int    EimpPrice            = PRICE_CLOSE;
extern bool   UseBOMP              = true;
extern double BompSmoothPeriod     = 90;
extern double BompSmoothPhase      =  0;
//
//
//
//
//

double valueUp[];
double valueDn[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(2);
   SetIndexBuffer(0,valueUp); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,valueDn); SetIndexStyle(1,DRAW_HISTOGRAM);
   return(0);
}
int deinit()
{
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double work[][12];
#define _osmaFast  0
#define _osmaSlow  1
#define _osmaSign  2
#define _osmaOsma  3
#define _osmaTren  4
#define _eimpema   5
#define _eimpmacdv 6
#define _eimpmacds 7
#define _eimpmacdo 8
#define _eimpTren  9
#define _bomp     10
#define _bompTren 11


int start()
{
   int i,r,counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(Bars-counted_bars,Bars-1);
           if (ArrayRange(work,0)!=Bars) ArrayResize(work,Bars);

   //
   //
   //
   //
   //

      double osmaAFast = 2.0 / (1.0 + OSMAFastPeriod);
      double osmaASlow = 2.0 / (1.0 + OSMASlowPeriod);
      double osmaASign = 2.0 / (1.0 + OSMASignalPeriod);
      double eimpAlpha = 2.0 / (1.0 + EimpMacdSignalPeriod);

      
      for(i=limit, r=Bars-i-1; i>=0; i--,r++)
      {
         double price = iMA(NULL,0,1,0,MODE_SMA,OSMAPrice,i);
         if (r==0)
         {
            work[r][_osmaFast] = price;
            work[r][_osmaSlow] = price;
            work[r][_osmaSign] = price;
            continue;
         }

         //
         //
         //
         //
         //
           
         double result = 0;
         double max    = 0;

         if (UseOSMA)
         {
            max++;
            work[r][_osmaFast] = work[r-1][_osmaFast]+osmaAFast*(price-work[r-1][_osmaFast]);
            work[r][_osmaSlow] = work[r-1][_osmaSlow]+osmaASlow*(price-work[r-1][_osmaSlow]);
                   double macd = work[r][_osmaFast]-work[r][_osmaSlow];
            work[r][_osmaSign] = work[r-1][_osmaSign]+osmaASign*(macd -work[r-1][_osmaSign]);
            work[r][_osmaOsma] = macd-work[r][_osmaSign];
            work[r][_osmaTren] = 0;
                  if (work[r][_osmaOsma]>work[r-1][_osmaOsma] && work[r][_osmaOsma]>0) work[r][_osmaTren]= 1;
                  if (work[r][_osmaOsma]<work[r-1][_osmaOsma] && work[r][_osmaOsma]<0) work[r][_osmaTren]=-1;
                     result += work[r][_osmaTren];
         }
         if (UseEldersImpulse)
         {
            max++;
            work[r][_eimpema]   = iMA(NULL,0,EimpEmaPeriod,0,MODE_EMA,EimpPrice,i); 
            work[r][_eimpmacdv] = iMA(NULL,0,EimpMacdFastPeriod,0,MODE_EMA,EimpPrice,i)-iMA(NULL,0,EimpMacdSlowPeriod,0,MODE_EMA,EimpPrice,i);
            work[r][_eimpmacds] = work[r-1][_eimpmacds]+eimpAlpha*(work[r][_eimpmacdv]-work[r-1][_eimpmacds]);
            work[r][_eimpmacdo] = work[r][_eimpmacdv]-work[r][_eimpmacds];
            work[r][_eimpTren]  = 0;
                  if (work[r][_eimpema]<work[r-1][_eimpema] && work[r][_eimpmacdo]<work[r-1][_eimpmacdo]) work[r][_eimpTren] = -1;
                  if (work[r][_eimpema]>work[r-1][_eimpema] && work[r][_eimpmacdo]>work[r-1][_eimpmacdo]) work[r][_eimpTren] =  1;
                     result += work[r][_eimpTren];
         }         
         if (UseBOMP)
         {
            max++;
            double range = MathMax(High[i]-Low[i],Point);
            double buo   = (High[i]-Open[i])/range;
            double buc   = (Close[i]-Low[i])/range;
            double buoc  = MathMax(Close[i]-Open[i],0)/range;
            double beo   = (Open[i]-Low[i])/range;
            double bec   = (High[i]-Close[i])/range;
            double beoc  = MathMax(Open[i]-Close[i],0)/range;
               work[r][_bompTren] = work[r-1][_bompTren];
               work[r][_bomp]     = iSmooth((buo+buc+buoc)/3.0-(beo+bec+beoc)/3.0,BompSmoothPeriod,BompSmoothPhase,i);
                  if (work[r][_bomp]>0) work[r][_bompTren] =  1;
                  if (work[r][_bomp]<0) work[r][_bompTren] = -1;
                     result += work[r][_bompTren];
         }
         
         //
         //
         //
         //
         //

        valueUp[i] = EMPTY_VALUE;         
        valueDn[i] = EMPTY_VALUE;         
           if (result== max) valueUp[i] = 1;
           if (result==-max) valueDn[i] = 1;
      }
   return(0);
}

//------------------------------------------------------------------
//                                                                  
//------------------------------------------------------------------
//
//
//
//
//

double wrk[][10];

#define bsmax  5
#define bsmin  6
#define volty  7
#define vsum   8
#define avolty 9

//
//
//
//
//

double iSmooth(double price, double length, double phase, int i, int s=0)
{
   if (length <=1) return(price);
   if (ArrayRange(wrk,0) != Bars) ArrayResize(wrk,Bars); s*= 10;
   
   int r = Bars-i-1; 
      if (r==0) { for(int k=0; k<7; k++) wrk[r][k+s]=price; for(; k<10; k++) wrk[r][k+s]=0; return(price); }

   //
   //
   //
   //
   //
   
      double len1   = MathMax(MathLog(MathSqrt(0.5*(length-1)))/MathLog(2.0)+2.0,0);
      double pow1   = MathMax(len1-2.0,0.5);
      double del1   = price - wrk[r-1][bsmax+s];
      double del2   = price - wrk[r-1][bsmin+s];
      double div    = 1.0/(10.0+10.0*(MathMin(MathMax(length-10,0),100))/100);
      int    forBar = MathMin(r,10);
	
         wrk[r][volty+s] = 0;
               if(MathAbs(del1) > MathAbs(del2)) wrk[r][volty+s] = MathAbs(del1); 
               if(MathAbs(del1) < MathAbs(del2)) wrk[r][volty+s] = MathAbs(del2); 
         wrk[r][vsum+s] =	wrk[r-1][vsum+s] + (wrk[r][volty+s]-wrk[r-forBar][volty+s])*div;
         
         //
         //
         //
         //
         //
   
         wrk[r][avolty+s] = wrk[r-1][avolty+s]+(2.0/(MathMax(4.0*length,30)+1.0))*(wrk[r][vsum+s]-wrk[r-1][avolty+s]);
            if (wrk[r][avolty+s] > 0)
               double dVolty = wrk[r][volty+s]/wrk[r][avolty+s]; else dVolty = 0;   
	               if (dVolty > MathPow(len1,1.0/pow1)) dVolty = MathPow(len1,1.0/pow1);
                  if (dVolty < 1)                      dVolty = 1.0;

      //
      //
      //
      //
      //
	        
   	double pow2 = MathPow(dVolty, pow1);
      double len2 = MathSqrt(0.5*(length-1))*len1;
      double Kv   = MathPow(len2/(len2+1), MathSqrt(pow2));

         if (del1 > 0) wrk[r][bsmax+s] = price; else wrk[r][bsmax+s] = price - Kv*del1;
         if (del2 < 0) wrk[r][bsmin+s] = price; else wrk[r][bsmin+s] = price - Kv*del2;
	
   //
   //
   //
   //
   //
      
      double R     = MathMax(MathMin(phase,100),-100)/100.0 + 1.5;
      double beta  = 0.45*(length-1)/(0.45*(length-1)+2);
      double alpha = MathPow(beta,pow2);

         wrk[r][0+s] = price + alpha*(wrk[r-1][0+s]-price);
         wrk[r][1+s] = (price - wrk[r][0+s])*(1-beta) + beta*wrk[r-1][1+s];
         wrk[r][2+s] = (wrk[r][0+s] + R*wrk[r][1+s]);
         wrk[r][3+s] = (wrk[r][2+s] - wrk[r-1][4+s])*MathPow((1-alpha),2) + MathPow(alpha,2)*wrk[r-1][3+s];
         wrk[r][4+s] = (wrk[r-1][4+s] + wrk[r][3+s]); 

   //
   //
   //
   //
   //

   return(wrk[r][4+s]);
}

